/******************************************************************************
  Copyright 2013 Tom Cornall

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.  
 ******************************************************************************/
#include "sr.h"

/*
 *
 */
void srInit(void)
{
    DDRC |= (1 << PC4); // D
    DDRC |= (1 << PC5); // C
    DDRC |= (1 << PC6); // OE
}

/*
 *
 */
void srClear(void)
{
    PORTC &= ~(1 << PC5);
    PORTC &= ~(1 << PC4);
    for (uint8_t i = 0; i < 24; i++) {
        PORTC |= (1 << PC5);
        PORTC &= ~(1 << PC5);
    }
}

/*
 *
 */
void srSet(uint8_t pos)
{
    PORTC &= ~(1 << PC5);
    PORTC &= ~(1 << PC4);
    PORTC |= (1 << PC4);
    PORTC |= (1 << PC5);
    PORTC &= ~(1 << PC5);
    PORTC &= ~(1 << PC4);

    for (uint8_t i = 0; i < pos; i++) {
        PORTC |= (1 << PC5);
        PORTC &= ~(1 << PC5);
    }
}
